precision highp float;//精度不要调整
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform float textureStepWidth;
uniform float textureStepHeight;
uniform float blurSize;

const vec2 blurCenter = vec2(0.5,0.5);

vec4 getValidColor(vec2 newTextureCoordinate, float weight){
    vec4 fragmentColor;
    if (newTextureCoordinate.x >= 0.0 && newTextureCoordinate.x <= 1.0 && newTextureCoordinate.y >= 0.0 && newTextureCoordinate.y <= 1.0){
        return texture2D(inputImageTexture, newTextureCoordinate) * weight;
    }
    return texture2D(inputImageTexture, textureCoordinate) * weight;
}

void main(){
    vec2 directionOfCoor = blurCenter - textureCoordinate;
    directionOfCoor = directionOfCoor / length(directionOfCoor);
    vec2 samplingOffset = directionOfCoor * vec2(textureStepWidth, textureStepHeight) * blurSize;

//    float tempProgress = 1.0 - progress;
    float tempProgress = 0.0;
    float weight1 = 0.227027;
    weight1 = weight1 + (1.0-weight1) * tempProgress;
    tempProgress = 1.0 - tempProgress;
    float weight2 = 0.1945946 * tempProgress;
    float weight3 = 0.1216216 * tempProgress;
    float weight4 = 0.054054 * tempProgress;
    float weight5 = 0.016216 * tempProgress;
    vec4 fragmentColor;
    fragmentColor = getValidColor(textureCoordinate, weight1);
    fragmentColor += getValidColor(textureCoordinate + samplingOffset, weight2);
    fragmentColor += getValidColor(textureCoordinate + (2.0 * samplingOffset), weight3);
    fragmentColor += getValidColor(textureCoordinate + (3.0 * samplingOffset), weight4);
    fragmentColor += getValidColor(textureCoordinate + (4.0 * samplingOffset), weight5);
    fragmentColor += getValidColor((textureCoordinate - samplingOffset), weight2);
    fragmentColor += getValidColor(textureCoordinate - (2.0 * samplingOffset), weight3);
    fragmentColor += getValidColor(textureCoordinate - (3.0 * samplingOffset), weight4);
    fragmentColor += getValidColor(textureCoordinate - (4.0 * samplingOffset), weight5);
    gl_FragColor = fragmentColor;
}