precision mediump float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float sepCount;//要分割的数量
uniform bool isHor;//是否是水平分割
uniform float displayRatio;//要展示的比例[0,1]

void main(){
    if (sepCount == 0.0 || displayRatio == 1.0){
        gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
    } else {
        float one = 1.0 / sepCount;
        if (isHor){
            //水平百叶窗
            float index = floor(textureCoordinate.y / one);
            if (textureCoordinate.y >= one * index + one * displayRatio){
                gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
            } else {
                gl_FragColor = vec4(0.);
            }
        } else {
            float index = floor(textureCoordinate.x / one);
            if (textureCoordinate.x >= one * index + one * displayRatio){
                gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
            } else {
                gl_FragColor = vec4(0.);
            }
        }
    }


}