precision mediump float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform highp float aspectRatio;
uniform highp vec2 center;
uniform highp float radius;
uniform highp float scale;

vec4 getBulgedistortionColor(){
    highp vec2 textureCoordinateToUse = vec2(textureCoordinate.x, (textureCoordinate.y * aspectRatio + 0.5 - 0.5 * aspectRatio));
    highp float dist = distance(center, textureCoordinateToUse);
    textureCoordinateToUse = textureCoordinate;
    if (dist < radius){
        textureCoordinateToUse -= center;
        highp float percent = 1.0 - ((radius - dist) / radius) * scale;
        percent = percent * percent;
        textureCoordinateToUse = textureCoordinateToUse * percent;
        textureCoordinateToUse += center;
    }
    return texture2D(inputImageTexture, textureCoordinate);
}

void main(){
    if (radius <= 0.0 || scale == 0.0 || aspectRatio == 0.0){
        gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
    } else {
        gl_FragColor = getBulgedistortionColor();
    }
}