precision mediump float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform bool enableBorder;
uniform vec4 vColor;
uniform vec4 vBgColor;
uniform float angle;
uniform bool toDrawBorder;
uniform bool toDrawBg;



mat2 rotate2d(float angle){
    return mat2(cos(angle), -sin(angle), sin(angle), cos(angle));
}



void main(){
    if(enableBorder){
        if (toDrawBorder){//仅绘制描边
            gl_FragColor = vColor;
        }else{
            if(toDrawBg){//toDrawBg 绘制背景
                gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
            }else {
                vec2 newCoordinate = textureCoordinate;
                // move space from the center to the vec2(0.0)
                newCoordinate -= vec2(0.5);
                // rotate the space
                newCoordinate = rotate2d(angle) * newCoordinate;
                // move it back to the original place
                newCoordinate += vec2(0.5);
                vec4 picTextire = texture2D(inputImageTexture, newCoordinate);

                gl_FragColor = picTextire;
            }
        }
    }else{
        gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
    }

}

