precision mediump float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform float angle;//角度
uniform vec4 maskColor;//蒙版颜色
uniform bool showMask;//是否显示蒙版
const float PI = 3.14159265358979323846;

//获取 newCoordinate 与 x = 0.5 (y<0.5)这条直线的夹角弧度
float getAngle(vec2 newCoordinate){
    if (newCoordinate.x == 0.5){
        if (newCoordinate.y < 0.5){
            return 0.0;
        } else if (newCoordinate.y == 0.5){
            return PI /2.0;
        } else {
            return PI;
        }
    }
    if (newCoordinate.y == 0.5 && newCoordinate.x < 0.5){
        return PI * 3.0 / 2.0;
    }
    if (newCoordinate.x > 0.5 && newCoordinate.y < 0.5){
        //右上。与 x=0.5 的夹角
        return atan((newCoordinate.x-0.5)/(0.5-newCoordinate.y));
    } else if (newCoordinate.x > 0.5 && newCoordinate.y > 0.5){
        //右下。与 y=0.5 的夹角
        return PI /2.0 + atan((newCoordinate.y-0.5)/(newCoordinate.x-0.5));
    } else if (newCoordinate.x < 0.5 && newCoordinate.y > 0.5){
        //左下。与 x=0.5 的夹角
        return PI + atan((0.5 - newCoordinate.x)/(newCoordinate.y-0.5));
    } else if (newCoordinate.x < 0.5 && newCoordinate.y < 0.5){
        //左上。与 y=0.5 的夹角
        return 3.0 * PI /2.0 + atan((0.5 - newCoordinate.y)/(0.5 - newCoordinate.x));
    }

    return 0.0;
}


void main(){
    vec2 newCoordinate = textureCoordinate;
    if(showMask){
        float radian = angle * PI / 180.0;//角度转弧度
        if (angle == 360.0){
            gl_FragColor = maskColor;
        } else {
            if (getAngle(newCoordinate) < radian){
                gl_FragColor = maskColor;
            } else {
                gl_FragColor = vec4(0.);
            }
        }
    }else{
        gl_FragColor = texture2D(inputImageTexture, newCoordinate);
    }

}