precision mediump float;//精度为float
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;//纹理位置接收于vertex_shader
uniform float progress;
uniform bool scaleFlag;
uniform vec4 whiteMask;//颜色遮罩层
const float PI = 3.1415926;
const float maxAmplitude = 0.1;//最大缩放幅度
void main() {
    float endProgress = 0.8;
    if(progress>endProgress){
        vec4 mask;
        if(scaleFlag){
            float amplitude = 1.0;
            float scaleAmplitude = 1.0 -  maxAmplitude * amplitude;
            amplitude = 0.5*(1.0-scaleAmplitude);
            vec2 textCoor = vec2(amplitude+textureCoordinate.x*scaleAmplitude, amplitude+textureCoordinate.y*scaleAmplitude);
            mask = texture2D(inputImageTexture, textCoor);
        }else{
            mask = texture2D(inputImageTexture, textureCoordinate);
        }
        gl_FragColor = mask;
    }else{
        float amplitude = abs(sin(progress * PI / endProgress / 2.0));//振幅: [0.0,1.0]
        float maskAmplitude = 0.6 * amplitude;
        vec4 mask;
        if(scaleFlag){
            float scaleAmplitude = 1.0 -  maxAmplitude * amplitude;
            amplitude = 0.5*(1.0-scaleAmplitude);
            vec2 textCoor = vec2(amplitude+textureCoordinate.x*scaleAmplitude, amplitude+textureCoordinate.y*scaleAmplitude);
            mask = texture2D(inputImageTexture, textCoor);//纹理坐标对应的纹素(RGBA)
        }else{
            mask = texture2D(inputImageTexture, textureCoordinate);
        }
        //利用混合方程式; 白色图层 + 原始纹理图片颜色 来进行混合
        gl_FragColor = mix(mask, whiteMask, 0.6 - maskAmplitude);
    }
}