precision mediump float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;


uniform int showIndex;//显示的区域 0:全显示 1：左上 2：右上  3：右下 4：左下
uniform bool showMask;//是否显示蒙版
uniform vec4 maskColor;//蒙版颜色
const vec4 borderColor = vec4(1.0, 1.0, 1.0, 1.0);//边框颜色
const float borderWidth = 0.01;

void main(){
    vec2 newTextureCoordinate = textureCoordinate;
    if (showMask){
        if (newTextureCoordinate.x <= borderWidth || newTextureCoordinate.x > 1.0 - borderWidth
        || newTextureCoordinate.y <= borderWidth || newTextureCoordinate.y > 1.0 - borderWidth){
            gl_FragColor = borderColor;
        } else {
            gl_FragColor = maskColor;
        }
    } else {
        if (showIndex == 0){
            gl_FragColor = texture2D(inputImageTexture, newTextureCoordinate);
        } else if (showIndex == 1){
            //左上
            if (newTextureCoordinate.x >= 0.0 && newTextureCoordinate.x <0.5 && newTextureCoordinate.y >= 0.0 && newTextureCoordinate.y <0.5){
                gl_FragColor = texture2D(inputImageTexture, newTextureCoordinate);
            } else {
                gl_FragColor = vec4(0.);
            }
        } else if (showIndex == 2){
            //右上
            if (newTextureCoordinate.x >= 0.5 && newTextureCoordinate.x <1.0 && newTextureCoordinate.y >= 0.0 && newTextureCoordinate.y < 0.5){
                gl_FragColor = texture2D(inputImageTexture, newTextureCoordinate);
            } else {
                gl_FragColor = vec4(0.);
            }
        } else if (showIndex == 3){
            //右下
            if (newTextureCoordinate.x >= 0.5 && newTextureCoordinate.x <1.0 && newTextureCoordinate.y >= 0.5 && newTextureCoordinate.y < 1.0){
                gl_FragColor = texture2D(inputImageTexture, newTextureCoordinate);
            } else {
                gl_FragColor = vec4(0.);
            }
        } else if (showIndex == 4){
            //右上
            if (newTextureCoordinate.x >= 0.0 && newTextureCoordinate.x <0.5 && newTextureCoordinate.y >= 0.5 && newTextureCoordinate.y <1.0){
                gl_FragColor = texture2D(inputImageTexture, newTextureCoordinate);
            } else {
                gl_FragColor = vec4(0.);
            }
        } else {
            gl_FragColor = vec4(0.);
        }
    }
}