precision mediump float;//精度为float
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;//纹理位置接收于vertex_shader
uniform float progress;
const vec3 weighting = vec3(0.2125, 0.7154, 0.0721); //借用GPUImage的值
void main() {
    float finalProgress = 1.0 - progress;
    if(finalProgress<0.0){
        finalProgress = 0.0;
    }
    vec4 mask = texture2D(inputImageTexture, textureCoordinate);
    float temp = dot(mask.rgb, weighting);
    float r = (mask.r-temp)/mask.r*finalProgress+temp;
    float g = (mask.g-temp)/mask.g*finalProgress+temp;
    float b = (mask.b-temp)/mask.b*finalProgress+temp;
    gl_FragColor = vec4(vec3(r,g,b), 1.0);
}