precision mediump float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform float progress;
uniform float moveDistance;

void main(){
    // 根据传入的进度计算transX
    float transX = moveDistance * progress;
    if (transX <= 0.0){
        gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
    } else {
        //横向切割
        if (textureCoordinate.y < 0.5){
            //上半部分左移
            float newX = textureCoordinate.x - transX;
            while (newX < -1.0){
                newX = newX + 1.0;
            }
            vec2 newCoordinate = vec2(abs(newX), textureCoordinate.y);
            gl_FragColor=texture2D(inputImageTexture, newCoordinate);
        } else {
            //下半部分右移
            float newX = textureCoordinate.x + transX;
            while (newX > 1.0){
                newX = ceil(newX/1.0) - newX;
            }
            vec2 newCoordinate = vec2(newX, textureCoordinate.y);
            gl_FragColor=texture2D(inputImageTexture, newCoordinate);
        }
    }
}
