precision mediump float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform int sepCount;//需要分割的数量
uniform bool isMirror;//是否镜像
uniform bool isHorization;//是否水平分割
uniform float tranValue;//移动的距离

void main(){
    vec2 newCoordinate = textureCoordinate;
    if (tranValue == 0.0){
        gl_FragColor = texture2D(inputImageTexture, newCoordinate);
    } else {
        int area = -1;//区域。从 0 开始
        float dis = 1.0 / float(sepCount);
        if (isHorization){
            area = int((newCoordinate.y / dis));
        } else {
            area = int((newCoordinate.x / dis));
        }
        bool isOdd = mod(float(area), 2.0) != 0.0;//奇数
        if (isHorization){
            if (isOdd){
                newCoordinate.x += tranValue;
            } else {
                newCoordinate.x -= tranValue;
            }
        } else {
            if (isOdd){
                newCoordinate.y += tranValue;
            } else {
                newCoordinate.y -= tranValue;
            }
        }
        if (isMirror || (newCoordinate.x >= 0.0 && newCoordinate.x <= 1.0 && newCoordinate.y >= 0.0 && newCoordinate.y <= 1.0)){
            gl_FragColor = texture2D(inputImageTexture, newCoordinate);
        } else {
            gl_FragColor = vec4(0.);
        }
    }

}