precision mediump float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform vec2 p1;//直线经过的第一个点
uniform vec2 p2;//直线经过的第二个点
uniform int showIndex;//0:全部显示 1：显示直线左侧的区域  2：显示直线右侧的区域

//判断 curCorrdinate 在两点 coordiante1 和  coordiante2 的左侧还是右侧
//Tmp > 0 在左侧 Tmp = 0 在线上 Tmp < 0 在右侧
float checkLineArea(vec2 coordiante1, vec2 coordiante2, vec2 curCorrdinate){
    float resultArea = (coordiante1.y - coordiante2.y) * curCorrdinate.x + (coordiante2.x - coordiante1.x) * curCorrdinate.y + coordiante1.x * coordiante2.y - coordiante2.x * coordiante1.y;
    return -resultArea;
}

void main(){
    vec2 newCoordinate = textureCoordinate;
    if (showIndex == 1){
        float area = checkLineArea(p1, p2, newCoordinate);
        if (area >= 0.0){
            //显示直线左侧区域
            gl_FragColor = texture2D(inputImageTexture, newCoordinate);
        } else {
            gl_FragColor = vec4(0.);
        }
    } else if (showIndex == 2){
        float area = checkLineArea(p1, p2, newCoordinate);
        if (area < 0.0){
            //显示直线右侧区域
            gl_FragColor = texture2D(inputImageTexture, newCoordinate);
        } else {
            gl_FragColor = vec4(0.);
        }
    } else {
        gl_FragColor = texture2D(inputImageTexture, newCoordinate);
    }
}