precision mediump float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform bool isHorization;//是否水平分割
uniform float tranValue;//移动的距离
uniform float start;//开始显示的区域
uniform float end;//终止显示的区域
uniform vec4 maskColor;//蒙版颜色

void main(){
    vec2 newCoordinate = textureCoordinate;
    if (tranValue >= 0.0){
        bool showMask = false;
        if(isHorization){
            if(newCoordinate.y >= start + tranValue && newCoordinate.y <= end + tranValue){
                showMask = true;
            }
        }else{
            if(newCoordinate.x >= start + tranValue && newCoordinate.x <= end + tranValue){
                showMask = true;
            }
        }
        if(showMask){
            gl_FragColor = maskColor;
        } else {
            gl_FragColor = texture2D(inputImageTexture, newCoordinate);
        }
    } else{
        gl_FragColor = texture2D(inputImageTexture, newCoordinate);
    }

}