//径向模糊效果
const float MAXRADIALBLURSIZE = 100.0;//最大径向模糊数值

//获取径向模糊后的颜色
vec4 getRadialBlurColor(sampler2D inputImageTexture, vec2 newTextureCoordinate,float radialBlurSize){
    if(radialBlurSize < 0.0){
        radialBlurSize = 0.0;
    }else if(radialBlurSize > 100.0){
        radialBlurSize = 100.0;
    }
    float realBlurSize = 0.008 * radialBlurSize / MAXRADIALBLURSIZE;
    highp vec2 dir = newTextureCoordinate - 0.5;//方向
    highp vec3 color = vec3(0.0);
    const int len = 10;
    for (int i= -len; i <= len; i++){
        highp vec2 blurCoord = newTextureCoordinate + float(i)*dir*2.0*realBlurSize;
        blurCoord = abs(blurCoord);
        if (blurCoord.x > 1.0){
            blurCoord.x = 2.0 - blurCoord.x;
        }
        if (blurCoord.y > 1.0){
            blurCoord.y = 2.0 - blurCoord.y;
        }
        color += texture2D(inputImageTexture, blurCoord).rgb;
    }
    color /= float(2*len+1);
    return vec4(color, 1.0);
}