//旋转模糊效果

//获取旋转模糊后的颜色
vec4 getRotateBlurColor(sampler2D inputImageTexture, vec2 newTextureCoordinate, float inputWidth, float inputHeight, float intensity){
    vec2 resolution = vec2(inputWidth, inputHeight);
    vec2 rotateCenter = resolution * 0.5;
    vec2 realCoord = newTextureCoordinate * resolution;
    vec2 dxy = realCoord - rotateCenter;
    float r = length(dxy);
    float angle = atan(dxy.y, dxy.x);
    int num = 15;

    vec3 color = vec3(0.0);
    float step = 0.01;
    for (int i = 0; i < num; i++)
    {
        angle += (step * intensity);

        float  newX = r*cos(angle) + rotateCenter.x;
        float  newY = r*sin(angle) + rotateCenter.y;
        newX = abs(newX);
        if (newX > resolution.x)
        newX = resolution.x - mod(newX, resolution.x);
        newY = abs(newY);
        if (newY > resolution.y)
        newY = resolution.y - mod(newY, resolution.y);
        color += texture2D(inputImageTexture, vec2(newX, newY)/resolution).rgb;
    }
    color /= float(num);
    return vec4(color, 1.0);
}