precision mediump float;//精度为float
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;//纹理位置接收于vertex_shader
uniform float progress;
uniform float photoWidth;
uniform float photoHeight;
const vec2 mosaicSize = vec2(10.0, 10.0);//马赛克Size
vec4 getMosaicColor(vec2 texSize) {
    vec2 intXY = vec2(textureCoordinate.x * texSize.x, textureCoordinate.y * texSize.y);//实际图像位置
    //floor(x)内建函数: 表示返回小于/等于x的最大整数值
    vec2 XYMosaic = vec2(floor(intXY.x/mosaicSize.x) * mosaicSize.x, floor(intXY.y/mosaicSize.y) * mosaicSize.y);
    //XYMosaic表示小马赛克的坐标，然后需要换算出马赛克的纹理坐标
    vec2 UVMosaic = vec2(XYMosaic.x/texSize.x, XYMosaic.y/texSize.y);
    vec4 color = texture2D(inputImageTexture, UVMosaic);
    return color;
}
void main() {
    float finalProgress = progress;
    if(finalProgress<=1.0){
        if(floor(textureCoordinate.y*10.0)+textureCoordinate.x<=finalProgress*10.0){
            gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
        }else{
            vec2 texSize = vec2(photoWidth, photoHeight);//纹理图片Size
            gl_FragColor = getMosaicColor(texSize);
        }
    }else{
        gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
    }
}