precision mediump float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float textureStepWidth;
uniform float textureStepHeight;
void main(){
    float amplitude = progress;
    if(amplitude<=1.0){
        vec2 tex_offset =vec2(textureStepWidth,textureStepHeight);
        vec4 orColor=texture2D(inputImageTexture,textureCoordinate);
        float orAlpha=orColor.a;
        //0-1 清晰变模糊
        float weight1 = 0.227027;
        weight1 = weight1+(1.0-weight1)*amplitude;
        amplitude = 1.0 - amplitude;
        float weight2 = 0.1945946 * amplitude;
        float weight3 = 0.1216216 * amplitude;
        float weight4 = 0.054054 * amplitude;
        float weight5 = 0.016216 * amplitude;
        //根据当前位置的像素偏移的位置的像素乘以相应的权重，然后相加求平均值，次数越多模糊程度越大
        vec3 color=orColor.rgb*weight1;
        //水平模糊
        color+=texture2D(inputImageTexture,textureCoordinate+vec2(tex_offset.x * float(1), 0.0)).rgb*weight2;
        color+=texture2D(inputImageTexture,textureCoordinate-vec2(tex_offset.x * float(1), 0.0)).rgb*weight2;
        color+=texture2D(inputImageTexture,textureCoordinate+vec2(tex_offset.x * float(2), 0.0)).rgb*weight3;
        color+=texture2D(inputImageTexture,textureCoordinate-vec2(tex_offset.x * float(2), 0.0)).rgb*weight3;
        color+=texture2D(inputImageTexture,textureCoordinate+vec2(tex_offset.x * float(3), 0.0)).rgb*weight4;
        color+=texture2D(inputImageTexture,textureCoordinate-vec2(tex_offset.x * float(3), 0.0)).rgb*weight4;
        color+=texture2D(inputImageTexture,textureCoordinate+vec2(tex_offset.x * float(4), 0.0)).rgb*weight5;
        color+=texture2D(inputImageTexture,textureCoordinate-vec2(tex_offset.x * float(4), 0.0)).rgb*weight5;
        //垂直模糊
        color+=texture2D(inputImageTexture,textureCoordinate+vec2(0.0,tex_offset.y * float(1))).rgb*weight2;
        color+=texture2D(inputImageTexture,textureCoordinate-vec2(0.0,tex_offset.y * float(1))).rgb*weight2;
        color+=texture2D(inputImageTexture,textureCoordinate+vec2(0.0,tex_offset.y * float(2))).rgb*weight3;
        color+=texture2D(inputImageTexture,textureCoordinate-vec2(0.0,tex_offset.y * float(2))).rgb*weight3;
        color+=texture2D(inputImageTexture,textureCoordinate+vec2(0.0,tex_offset.y * float(3))).rgb*weight4;
        color+=texture2D(inputImageTexture,textureCoordinate-vec2(0.0,tex_offset.y * float(3))).rgb*weight4;
        color+=texture2D(inputImageTexture,textureCoordinate+vec2(0.0,tex_offset.y * float(4))).rgb*weight5;
        color+=texture2D(inputImageTexture,textureCoordinate-vec2(0.0,tex_offset.y * float(4))).rgb*weight5;
        gl_FragColor=vec4(color,orAlpha);
    }else{
        gl_FragColor=texture2D(inputImageTexture,textureCoordinate);
    }
}