precision mediump float;//精度为float
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
const float PI = 3.1415926;
const float maxJitter = 0.06;//最大抖动上限
const float colorROffset = 0.01;//红色颜色偏移
const float colorBOffset = -0.025;//绿色颜色偏移
float rand(float n) {
    //fract(x)返回x的小数部分，如果想得到【0，1】范围的小数值，可以将sin * 1
    //sin(n) * 极大值，带小数点，想要随机数算的比较低，乘的数就必须较大，噪声随机
    return fract(sin(n) * 43758.5453123);
}
void main() {
    float amplitude = abs(sin(progress * PI * 2.0));//振幅:[0,1,0,1,0]
    float jitter = rand(textureCoordinate.y) * 2.0 - 1.0;//像素随机偏移[-1,1]
    bool needOffset = abs(jitter) < maxJitter * amplitude;//是否要做偏移
    //获取纹理X值.根据needOffset，来计算它X撕裂, needOffset = YES，撕裂较大; needOffset = NO，撕裂较小
    float textureX = textureCoordinate.x + (needOffset ? jitter : (jitter * amplitude * 0.006));
    vec2 textureCoords = vec2(textureX, textureCoordinate.y);//撕裂后的纹理坐标x,y
    //颜色偏移3组颜色 1)根据撕裂后获取的纹理颜色值 2)撕裂后的纹理颜色偏移 3)撕裂后的纹理颜色偏移
    vec4 mask = texture2D(inputImageTexture, textureCoords);
    vec4 maskR = texture2D(inputImageTexture, textureCoords + vec2(colorROffset * amplitude, 0.0));
    vec4 maskB = texture2D(inputImageTexture, textureCoords + vec2(colorBOffset * amplitude, 0.0));
    //红色/蓝色部分发生撕裂
    gl_FragColor = vec4(maskR.r, mask.g, maskB.b, mask.a);
}