precision mediump float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform bool isAroundFlag;
uniform float alphaValue;
uniform bool isXFlag;
uniform float progress;
uniform int clockwise;
const float axis = 0.5;
const float deltaY = 0.5;
const vec2 boundMin = vec2(0.0, 0.0);
const vec2 boundMax = vec2(1.0, 1.0);
bool inBounds (vec2 p) {
    return all(lessThan(boundMin, p)) && all(lessThan(p, boundMax));
}
void main() {
    if(isAroundFlag){
        vec2 coordinate = textureCoordinate;
        vec2 result = vec2(-1.0);
        if (clockwise == 1) {
            if(isXFlag){
                result = (coordinate+vec2(-1.0+axis,-deltaY))*vec2(1.0/(1.0-(1.0-progress)*(1.0-(coordinate.y+axis))),1.0/progress) + vec2(1.0-axis, deltaY);
            }else{
                result = (coordinate+vec2(-1.0+axis,-deltaY))*vec2(1.0/progress,1.0/(1.0-(1.0-progress)*(1.0-(coordinate.x+axis)))) + vec2(1.0-axis, deltaY);
            }
        }else {
            if(isXFlag){
                result = (coordinate+vec2(-axis,-deltaY))*vec2(1.0/(1.0-(1.0-progress)*(coordinate.y-axis)),1.0/progress) + vec2(axis, deltaY);
            }else{
                result = (coordinate+vec2(-axis,-deltaY))*vec2(1.0/progress,1.0/(1.0-(1.0-progress)*(coordinate.x-axis))) + vec2(axis, deltaY);
            }
        }
        vec4 color;
        if (inBounds(result)) {
            color = vec4(texture2D(inputImageTexture, result).xyz,1.0);
            color = color * alphaValue;
            color = vec4(color.xyz,1.0);
        }else{
            color = vec4(0.0);
        }
        gl_FragColor = color;
    }else{
        vec4 color = texture2D(inputImageTexture, textureCoordinate);
        color = color * alphaValue;
        gl_FragColor = vec4(color.xyz,1.0);
    }
}