precision mediump float;//精度为float
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;//纹理位置接收于vertex_shader
uniform float offsetX;
const float width = 720.0;//宽度（像素）
const float height = 720.0;//宽度（像素）

uniform bool showMask;//是否显示蒙版
uniform vec4 maskColor;//蒙版的颜色

void main() {
    if(showMask){
        gl_FragColor = maskColor;
    }else{
        // 颜色偏移值，目前只偏移x轴
        vec2 offsetCoords = vec2(offsetX / width, 0);

        // 获取三组颜色：颜色偏移计算可以随意，只要偏移量很小即可
        // 原始颜色 + offset
        vec4 maskR = texture2D(inputImageTexture, textureCoordinate + offsetCoords);
        // 原始颜色 - offset
        vec4 maskB = texture2D(inputImageTexture, textureCoordinate - offsetCoords);
        // 原始颜色
        vec4 mask = texture2D(inputImageTexture, textureCoordinate);

        // 从3组颜色中分别取出 红色R，绿色G，蓝色B，透明度A填充到内置变量gl_FragColor内
        gl_FragColor = vec4(maskR.r, mask.g, maskB.b, mask.a);
    }
}