precision mediump float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
const float PI = 3.1415926;
const float fixBound = 0.1;
const vec2 center = vec2(0.5,0.5);
void main(){
    float amplitude = 1.0-sin(progress*PI);
    amplitude = amplitude * 0.70711;
    vec2 texCoord = textureCoordinate;
    float distance = distance(texCoord, center);//采样点坐标与中心点的距离
    if ((amplitude - fixBound) > 0.0 && (distance <= (amplitude + fixBound)) && (distance >= (amplitude - fixBound))) {
        float diff = (distance - amplitude); //输入 diff
        float moveDis = 20.0*diff*(diff-0.1)*(diff+0.1);
        vec2 unitDirectionVec = normalize(texCoord - center);//单位方向向量
        texCoord = texCoord + (unitDirectionVec * moveDis);//采样坐标偏移
    }
    gl_FragColor = texture2D(inputImageTexture, texCoord);
}