precision mediump float;
uniform sampler2D inputImageTexture;

uniform float progress;
uniform int clockwise;

varying vec2 textureCoordinate;

#define axis 0.5
#define deltaY 0.5
const vec2 boundMin = vec2(0.0, 0.0);
const vec2 boundMax = vec2(1.0, 1.0);

bool inBounds (vec2 p) {
    return all(lessThan(boundMin, p)) && all(lessThan(p, boundMax));
}

void main() {

    vec2 coordinate = textureCoordinate;
    vec2 result = vec2(-1.);
    if (clockwise == 1) {
        // 顺时针
        result = (coordinate + vec2(-1.0 + axis, -deltaY)) * vec2(1.0 / progress, 1.0/(1.0-(1.-progress)*(1.0-(coordinate.x + axis)))) + vec2(1.0-axis, deltaY);
    } else {
        // 逆时针
        result = (coordinate + vec2(-axis, -deltaY)) * vec2(1.0 / progress, 1.0 / (1.0 - (1.0 - progress) * (coordinate.x - axis))) + vec2(axis, deltaY);
    }

    if (inBounds(result)) {
        gl_FragColor = texture2D(inputImageTexture, result);
    } else {
        gl_FragColor = vec4(0.);
    }
}