precision mediump float;

uniform sampler2D inputImageTexture;

varying vec2 textureCoordinate;

uniform float angle;

mat2 rotate2d(float angle){
    return mat2(cos(angle), -sin(angle), sin(angle), cos(angle));
}

void main(){

    vec2 newCoordinate = textureCoordinate;
    // move space from the center to the vec2(0.0)
    newCoordinate -= vec2(0.5);
    // rotate the space
    newCoordinate = rotate2d(angle) * newCoordinate;
    // move it back to the original place
    newCoordinate += vec2(0.5);
    vec4 nColor=texture2D(inputImageTexture, newCoordinate);
    gl_FragColor=nColor;
}
