precision mediump float;//精度为float
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;//纹理位置接收于vertex_shader
uniform float progress;
const float maxScale = 1.1;//图片放大的上限
const float offset = 0.02;//颜色偏移步长
void main() {
    vec2 offsetCoords = vec2(offset, offset) * progress;//颜色偏移值范围[0,0.02]
    float scale = 1.0 + (maxScale - 1.0) * progress;//缩放范围[1.0-1.1]
    //放大纹理坐标 以及 获取3组颜色rgb：1）原始颜色+offsetCoords 2）原始颜色-offsetCoords 3）原始颜色
    vec2 weakTextureCoords = vec2(0.5, 0.5) + (textureCoordinate - vec2(0.5, 0.5)) / scale;
    vec4 maskR = texture2D(inputImageTexture, weakTextureCoords + offsetCoords);
    vec4 maskB = texture2D(inputImageTexture, weakTextureCoords - offsetCoords);
    vec4 mask = texture2D(inputImageTexture, weakTextureCoords);
    //maskR.r,mask.g,maskB.b 注意这3种颜色取值可以打乱或者随意发挥.不一定写死.只是效果会有不一样
    gl_FragColor = vec4(maskR.r*0.2+mask.r*0.2+maskB.r*0.2+mask.r*0.4, maskR.g*0.2+mask.g*0.2+maskB.g*0.2+mask.g*0.4,
        maskR.b*0.2+mask.b*0.2+maskB.b*0.2+mask.b*0.4, mask.a);//mask.a 获取原图的透明度
}