precision mediump float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform float scale;
uniform float transX;
uniform float transY;
uniform float rotate;

vec2 scaleCenter(vec2 newTextureCoordinate, float scaleValue){
    newTextureCoordinate -= vec2(0.5, 0.5);
    newTextureCoordinate = mat2(scaleValue, 0.0, 0.0, scaleValue) * newTextureCoordinate;
    newTextureCoordinate += vec2(0.5, 0.5);
    return newTextureCoordinate;
}
vec2 rotate2dCenter(vec2 newTextureCoordinate, float angle){
    newTextureCoordinate -= vec2(0.5);
    // rotate the space
    newTextureCoordinate = mat2(cos(angle), -sin(angle), sin(angle), cos(angle)) * newTextureCoordinate;
    // move it back to the original place
    newTextureCoordinate += vec2(0.5);
    return newTextureCoordinate;
}

void main(){
    vec2 newTextureCoordinate = textureCoordinate;
    newTextureCoordinate = scaleCenter(newTextureCoordinate, scale);
    newTextureCoordinate -= vec2(transX, transY);
    newTextureCoordinate = rotate2dCenter(newTextureCoordinate, rotate);
    gl_FragColor = texture2D(inputImageTexture, newTextureCoordinate);
}