precision mediump float;

uniform sampler2D inputImageTexture;
varying vec2 textureCoordinate;
uniform float scale;
uniform bool isMirror;

vec2 scaleCenter(vec2 newTextureCoordinate, float scaleValue){
    newTextureCoordinate -= vec2(0.5, 0.5);
    newTextureCoordinate = mat2(scaleValue, 0.0, 0.0, scaleValue) * newTextureCoordinate;
    newTextureCoordinate += vec2(0.5, 0.5);
    return newTextureCoordinate;
}

void main(){
    vec2 newCoordinate = textureCoordinate;
    newCoordinate = scaleCenter(newCoordinate, scale);
    vec4 nColor;
    if (isMirror){
        nColor = texture2D(inputImageTexture, newCoordinate);
    } else {
        if (newCoordinate.x < 0.0 || newCoordinate.x > 1.0 || newCoordinate.y < 0.0 || newCoordinate.y > 1.0){
            nColor = vec4(0.0);
        } else {
            nColor = texture2D(inputImageTexture, newCoordinate);
        }
    }
    gl_FragColor = nColor;
}
