precision mediump float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform float rotateAngle;//旋转的角度：范围 [-PI/2,PI/2]
uniform float progress;
uniform float splitNumber;

const float PI = 3.14159265358979323846;

void main() {

    float angle = rotateAngle + PI;
    float splitWidth = 1.0/splitNumber;
    vec4 color = texture2D(inputImageTexture, textureCoordinate);
    vec2 newCoordinate = textureCoordinate - vec2(0.5);
    float dist = sin(angle) * newCoordinate.x - cos(angle) * newCoordinate.y;

    float hidePixel = mod(dist, splitWidth);
    float showPixel = progress * splitWidth;

    if (hidePixel > showPixel) {
        color = vec4(.0);
    }

    gl_FragColor =color;
}
