precision mediump float;//精度 为float
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;//纹理位置接收于vertex_shader
uniform float progress;
float maxAlpha = 1.0;//透明度上限值
const float maxScale = 1.8;//图片放大的上限
void main() {
    float alpha = maxAlpha * (1.0 - progress);//当前透明度[0.4，0]
    float scale = 1.0 + (maxScale - 1.0) * progress;//当前缩放比例[1.0，1.8]
    //获取放大后的纹理坐标，将顶点坐标对应的纹理坐标的x/y值到中心点的距离，缩小一定的比例，仅仅只是改变了纹理坐标，而保持顶点坐标不变，从而达到拉伸效果
    //理解：纹理坐标映射到顶点坐标，中心点压缩后的坐标对应顶点坐标
    float weakX = 0.5 + (textureCoordinate.x - 0.5) / scale;
    float weakY = 0.5 + (textureCoordinate.y - 0.5) / scale;
    vec2 weakTextureCoords = vec2(weakX, weakY);
    vec4 weakMask = texture2D(inputImageTexture, weakTextureCoords);//获取当前像素点放大后的纹理坐标
    vec4 mask = texture2D(inputImageTexture, textureCoordinate);
    //颜色混合 内建函数mix / 混合方程式
    gl_FragColor = mask * (1.0 - alpha) + weakMask * alpha;
}