precision mediump float;

uniform sampler2D inputImageTexture;
varying highp vec2 textureCoordinate;

uniform vec4 maskColor;
uniform bool showMask;
void main(){

    //底层的图片
    lowp vec4 base = texture2D(inputImageTexture, textureCoordinate);
    //上层的mask(这里用纯色)
    lowp vec4 overlay = maskColor;
    if(showMask){
        //r
        mediump float r;
        if (overlay.r * base.a + base.r * overlay.a >= overlay.a * base.a) {
            r = overlay.a * base.a + overlay.r * (1.0 - base.a) + base.r * (1.0 - overlay.a);
        } else {
            r = overlay.r + base.r;
        }
        //g
        mediump float g;
        if (overlay.g * base.a + base.g * overlay.a >= overlay.a * base.a) {
            g = overlay.a * base.a + overlay.g * (1.0 - base.a) + base.g * (1.0 - overlay.a);
        } else {
            g = overlay.g + base.g;
        }
        //b
        mediump float b;
        if (overlay.b * base.a + base.b * overlay.a >= overlay.a * base.a) {
            b = overlay.a * base.a + overlay.b * (1.0 - base.a) + base.b * (1.0 - overlay.a);
        } else {
            b = overlay.b + base.b;
        }

        mediump float a = overlay.a + base.a - overlay.a * base.a;
        gl_FragColor = vec4(r, g, b, a);
    }else{
        gl_FragColor = base;
    }

}