precision mediump float;//精度为float

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;//纹理位置接收于vertex_shader

uniform float progress;

const float PI = 3.1415926;
const vec4 whiteMask = vec4(1.0, 1.0, 1.0, 1.0);//白色颜色遮罩层

void main() {
    float amplitude = 1.0 - 0.7 * abs(sin(progress * PI));//振幅: [1.0,0.3,1.0]
    vec4 mask = texture2D(inputImageTexture, textureCoordinate);//纹理坐标对应的纹素(RGBA)
    float synthesizeColor = 0.299 * mask.r + 0.587 * mask.g + 0.114 * mask.b;
    float wDistance = distance(mask,whiteMask);
    vec4 resultColor = vec4(0.0, 0.0, 0.0, 0.0);
    if(synthesizeColor>0.9){//重颜色，保持不变
        resultColor = mask;
    }else if(wDistance<(progress * 2.0 * 1.384)){//[0,1.384,0]
        resultColor = whiteMask;
    }else{
        resultColor = mask;
    }
    gl_FragColor = mask * (1.0 - amplitude) + resultColor * amplitude;
}